using System;
using UnityEngine;
using UnityEngine.UI;
using UnityEngine.XR;
using System.Collections;
using System.Collections.Generic;
using SimpleJSON;
using Object = UnityEngine.Object;
using System.Text.RegularExpressions;

namespace Cotyounoyume
{
    public class AddonTakeControlItem : MonoBehaviour 
    {
		public Atom atom;
		public EBATCore core;
		private float lastTime;
		
		#region takeControlOfExpression
		ReceiverBackup receiverBackup;
		VariableTriggerBackup variableTriggerBackup;
		CollisionTriggerBackup collisionTriggerBackup;
		#endregion
		
		#region addon common
		public AddonTakeControlItem(EBATCore core){
			atom = core.atom;
			this.core = core;
		}
		
		public void loadSettings(){
			try{
				
			}catch (Exception e){
				core.loggerE(e);
			}
		}
		
		public void applySettings(){
		}

		public void manage(float time){
			if(time == lastTime){
				time += 0.001f;
			}else if(time < lastTime){
				time = lastTime + 0.001f;
			}
			lastTime = time;
		}	
		
		public void OnDestroy(){
		}
		
		public void OnOrgasmStart()
		{
		}
		
		public void OnOrgasmStop()
		{
		}
		#endregion
		
		#region TakeControl
		public void TakeControlOfExpression(){
			Dictionary<VariableTrigger, JSONClass> res1 = Utility.CollectVariableTrigger();
			variableTriggerBackup = new VariableTriggerBackup(res1, atom);
			variableTriggerBackup.ClearTargetMorphs();
			
			Dictionary<CollisionTrigger, JSONClass> res2 = Utility.CollectCollisionTrigger();
			collisionTriggerBackup = new CollisionTriggerBackup(res2, atom);
			collisionTriggerBackup.ClearTargetMorphs();
			
//			Dictionary<Trigger, JSONClass> res = Utility.CollectAnimationTrigger();
		}
		
		public void ReturnControlOfExpression(){
			variableTriggerBackup.Recover();
			collisionTriggerBackup.Recover();
		}				
		#endregion
	}
}