#region using
using System;
using UnityEngine;
using System.Collections;
using System.Collections.Generic;
using SimpleJSON;
using System.Linq;
using System.Threading;
using System.Text.RegularExpressions;
#endregion

namespace Cotyounoyume{
	public class Expression2
	{
		#region common or UI Properties
		public Atom atom;
		public EBATCore core;
		public FaceMorphManager fmm;
		public bool expressionOnGlobal = true;
		public bool isExpressionActive = false;
		#endregion
		
		public Expression2(EBATCore core){
			this.atom = core.atom;
			this.core = core;
			
			fmm = new FaceMorphManager(this.atom);
		}

		public void loadSettings(){		
			try{
				expressionOnGlobal = core.settings["General"]["Expression On"].AsBool;
			}catch (Exception e){
				core.loggerE(e);
			}
		}
		
		public void update(){
			try{
				if(!expressionOnGlobal){return;}
				fmm.pickExpression(core.currentTime, core.getStage(), core.isDuringAfterglow, isStrongWave:core.isFirstTerm);
			}catch (Exception e){
				core.loggerE(e);
			}
		}
		
		public void testMax(){
			fmm.pickExpression(core.currentTime, 5, false);
		}
		
		public void testAfterGrow(){
			fmm.pickExpression(core.currentTime, 3, true);
		}
		
		public void manage(){
			try{
				if(!expressionOnGlobal){return;}
				this.isExpressionActive = fmm.isExpressionActive;
				fmm.manageStrength(core.currentTime);
			}catch (Exception e){
				core.loggerE(e);
			}
		}
		
		public void openMouth(float duration){
			fmm.openMouth(core.currentTime, duration, core.curStage, core.isDuringAfterglow);
		}

		public void stopExpression(){
			fmm.stopExpression();
		}

		public void resetExpression(){
			fmm.stopExpression();
			fmm.stopAllExpressionInPose();
		}
		
		public void OnDestroy(){
			fmm.OnDestroy();
			fmm = null;
		}
	}
}