#region using
using System;
using UnityEngine;
using System.Collections;
using System.Collections.Generic;
using SimpleJSON;
using System.Linq;
using System.Threading;
using System.Text.RegularExpressions;
using MVR.FileManagementSecure;
using MVR.FileManagement;
#endregion

namespace Cotyounoyume{
	public class UnityAssets
	{
		#region common or UI Properties
		public Atom atom;
		public EBATCore core;
		public bool disableLog;
		#endregion
		
		#region unityassets
		public Atom pee;
		public Atom button;
		public Atom UIAtom;
		public string peeNameBase = "Pee";
		public string peeName;
		public int peeCount = 0;
		public string peeUrl = "Custom/Assets/peeset.assetbundle";
		public string peeLongName = "assets/prefabs/peelong.prefab";
		public string peeShortName = "assets/prefabs/peeshort.prefab";
		public bool isPeeFree = true;
		public float freePeeTime = 0.0f;
		public float timePeeShort = 2.5f;
		public float timePeeLong = 4.0f;
		public float peeingRatio = 0.2f;
		public float peeingLongRatio = 0.5f;
		public bool peeingOnGlobal = true;
		
		public string mofmesPath;
		public string mofmesPackage;
		
		public string mofmesBasePath = "Custom/Assets/Mofme/mofme_fluids.assetbundle";
		public string mofmesLongName  = "assets/prefabs_fl/mofme_cumshot_m_hp.prefab";
		public string mofmesShortName = "assets/prefabs_fl/mofme_cumshot_m_hp.prefab";
		public float mofmesTime = 1.5f;
		
		#endregion
				
		public UnityAssets(EBATCore core){
			atom = core.atom;
			this.core = core;
			RemovePee();
		}
		
		public void loadSettings(){
			try{
				string tmpUrl  = core.settings["Peeing"]["PeeUrl"];
				peeUrl         = tmpUrl.Replace("SELF:/", "");
				peeLongName    = core.settings["Peeing"]["PeeLongName"];
				peeShortName   = core.settings["Peeing"]["PeeShortName"];
				peeingRatio    = core.settings["Peeing"]["Peeing Ratio"].AsFloat;
				peeingOnGlobal = core.settings["General"]["Peeing On"].AsBool;
			}catch (Exception e){
				core.loggerE(e);
			}
		}
		
		public void applySettings(){

		}
		
		public void maintenance(){
			
		}

		public void OnDestroy()
		{
			RemovePee();
		}
		
		public void RemovePee(){
			SuperController.singleton.RemoveAtom(pee);
		}
		
		public void SetPeeName(){
			peeName = peeNameBase + peeCount;
		}
		
		public void RemakePee(){
			RemovePee();
			peeCount++;
			makeUAPee();
		}
				
		#region UnityAssets functions
		public void makeUAPee(){
			SetPeeName();
			core.StartCoroutine(core.CreateAtom("CustomUnityAsset", peeName, (tmpatom)=>
			{
				pee = tmpatom;
				string bodyName = (core.gender=="Male") ? "penisTipControl" : "LabiaTrigger";
				Vector3 pos = Utility.getPositionFromTargetBodyname(atom, bodyName);
				Quaternion rot = Utility.getRotationFromTargetBodyname(atom, bodyName);
				pee.transform.SetPositionAndRotation(pos, rot);
				Utility.setParent2(pee, atom, bodyName);
				
				string fullpath = core.myPath;
				//for src/PAUSED_ADD_ME.cslist
				//fullpath = fullpath.Replace("Custom/Scripts/cotyounoyume/ExpressionBlushingAndTears/src", "");
				//for ADD_ME.cslist
				fullpath = fullpath.Replace("Custom/Scripts/cotyounoyume/ExpressionBlushingAndTears", "");
				fullpath += peeUrl;
				
				if(hasMofmeAssets() && core.gender == "Male"){
					fullpath = mofmesPath;
					peeLongName = mofmesLongName;
					peeShortName = mofmesShortName;
					timePeeLong  = mofmesTime;
					timePeeShort = mofmesTime;
				}
				Utility.setAssetBundleUrl(pee, fullpath);

				pee.hidden = true;
				pee.mainController.canGrabPosition = false;
				pee.mainController.canGrabRotation = false;
			}));
		}

		public void test1(){
			string bodyName = (core.gender=="Male") ? "penisTipControl" : "LabiaTrigger";
			Utility.resetParent(pee);
			Utility.setParent(pee, atom, bodyName);
			pee.transform.position = Utility.getPositionFromTargetBodyname(atom, bodyName);
			pee.transform.rotation = Utility.getRotationFromTargetBodyname(atom, bodyName);
			Vector3 pos = Utility.getPositionFromTargetBodyname(atom, bodyName);
			Utility.printPosition("pee: ", Utility.getPosition(pee.transform));
			Utility.printPosition("pos: ", Utility.getPosition(pos));
		}
		
		public void manage(float time){
			try{
				if(freePeeTime < time){
					isPeeFree = true;
					freePeeTime = 0.0f;
				}				
			}catch (Exception e){
				core.loggerE(e);
			}
		}		

		public void peeRandom(float time, bool force = false){
			if(peeingOnGlobal == false){
				return;
			}
			
			float randA = UnityEngine.Random.Range(0.0f, 1.0f);
			float randB = UnityEngine.Random.Range(0.0f, 1.0f);
			if(randA > peeingRatio && force == false){
				return;
			}
			
			if(randB < peeingLongRatio){
				resetUSPeeLong(time);
			}else{
				resetUSPeeShort(time);				
			}
		}
		
		public void resetUSPeeLong(float time){
			if(isPeeFree){
				Utility.resetAssetBundleName(pee, peeLongName);
				isPeeFree = false;
				freePeeTime = time + timePeeLong;
			}
		}
		
		public void resetUSPeeShort(float time){
			if(isPeeFree){
				Utility.resetAssetBundleName(pee, peeShortName);
				isPeeFree = false;
				freePeeTime = time + timePeeShort;
			}
		}
		
		public bool hasMofmeAssets(){
			string[] files = FileManagerSecure.GetFiles("AddonPackages", "*Fluids*");
			for(int i = files.Length - 1; i >= 0; i--){
				string fullpath = files[i] + ":/" + mofmesBasePath;
				if(FileManagerSecure.IsFileInPackage(fullpath)){
					mofmesPackage = files[i];
					mofmesPath = fullpath;
					return true;
				}
			}
			return false;
		}
		#endregion		
	}
}