using System;
using UnityEngine;
using UnityEngine.UI;
using UnityEngine.XR;
using System.Collections;
using System.Collections.Generic;
using SimpleJSON;

namespace Cotyounoyume
{
    public class WorldUIAddon1{
		public EBATCore core;
		public WorldUI worldUi;
		public AddonManager1 addonManager1;
		
		public AddonClothSimItem addonClothSim;
		public AddonTakeControlItem addonTakeControl;		
		
		public string strUndress           = "Undress Clothes";
		public string strUndressHalf       = "Undress(Half)";
		public string strUndressStop       = "Undress(Stop)";
		public string strReverse           = "Reverse Gravity";
		public string strUndressAndReverse = "Undress+Reverse";
		public string strUndressRecover    = "Reset";
		public string strUndressRemove     = "Remove Clothes";
		
		public string strExpandAddon1      = "Addon1[▶]";
		public string strExpandAddon1Alt   = "Addon1[◀]";
		
		public UIDynamicButton uiUndress;
		public UIDynamicButton uiUndressHalf;
		public UIDynamicButton uiUndressStop;
		public UIDynamicButton uiReverse;
		public UIDynamicButton uiUndressAndReverse;
		public UIDynamicButton uiUndressRecover;
		public UIDynamicButton uiUndressRemove;
		
		public UIDynamicButton uiExpandAddon1;
		public bool expandAddon1 = true;
		
		public string strTakeControlOfExpression = "Take Control Of Expression";
		public string strStopControlOfExpression = "Stop";
		public UIDynamicButton uiTakeControlOfExpression;
		public UIDynamicButton uiStopControlOfExpression;
		
		/*
		public UIDynamicButton uiTestButton1;
		public UIDynamicButton uiTestButton2;
		public UIDynamicButton uiTestButton3;
		public UIDynamicButton uiTestButton4;
		public string strTestButton1    = "test1 start";
		public string strTestButton2    = "test2 start";
		public string strTestButton3    = "test3 start";
		public string strTestButton4    = "test4 start";
		*/
		
		public WorldUIAddon1(WorldUI worldUi){
			this.worldUi = worldUi;
			this.core = worldUi.core;
			
			SetReference();
		}

		public void SetReference(){
			this.addonManager1 = core.addonManager1;
			this.addonClothSim         = addonManager1.addonClothSim;
			this.addonTakeControl      = addonManager1.addonTakeControl;
		}
		
		public void RemoveMenuBodyAddon(){
			UIDynamicButton[] buttons = {
				uiUndress, uiUndressHalf, uiUndressStop, uiReverse, uiUndressAndReverse, uiUndressRecover, uiUndressRemove,
				uiExpandAddon1, 
//				uiTakeControlOfExpression, uiStopControlOfExpression,
//				uiTestButton1, uiTestButton2, uiTestButton3, uiTestButton4,
			};

			UIDynamicSlider[] sliders = {
			};

			worldUi.RemoveMenuBodyImpl(buttons, sliders);
		}

		public void MakeMenuBodyPartExpandButton(string type){
			if(type == "Addon1"){
				uiExpandAddon1 = MakeButton(strExpandAddon1, -1, worldUi.line);
				uiExpandAddon1.button.onClick.AddListener(OnExpandAddon1);
			}
			worldUi.line++;
		}
		
		public void MakeMenuBodyPartCollapseButton(string type){
			if(type == "Addon1"){
				uiExpandAddon1 = MakeButton(strExpandAddon1Alt, -1, worldUi.line);
				uiExpandAddon1.button.onClick.AddListener(OnCollapseAddon1);
			}
			worldUi.line++;
		}
		
		public void MakeMenuBodyAddon(){
			if(expandAddon1){
				MakeMenuBodyPartCollapseButton("Addon1");
				MakeMenuBodyPartAddon1();
			}else{
				MakeMenuBodyPartExpandButton("Addon1");
			}
		}
		
		public void MakeMenuBodyPartAddon1(){
			#region DrawAddonUI
			uiUndressRecover = MakeButton(strUndressRecover, -1, worldUi.line);
			uiUndress = MakeButton(strUndress, 0, worldUi.line);
//			uiUndressHalf = MakeButton(strUndressHalf, 1, lineUndress);
			uiUndressStop = MakeButton(strUndressStop, 1, worldUi.line);
			uiReverse = MakeButton(strReverse, 2, worldUi.line);
			uiUndressAndReverse = MakeButton(strUndressAndReverse, 3, worldUi.line);
			uiUndressRemove = MakeButton(strUndressRemove, 4, worldUi.line);
			worldUi.line++;
			/* for next release
			int lineTakeControl = current + 8;
			uiTakeControlOfExpression = MakeButton(strTakeControlOfExpression, 0, lineTakeControl);
			uiStopControlOfExpression = MakeButton(strStopControlOfExpression, 1, lineTakeControl);
			
			int lineTest = current + 9;
			uiTestButton1 = MakeButton(strTestButton1, 0, lineTest);
			uiTestButton2 = MakeButton(strTestButton2, 1, lineTest);
			uiTestButton3 = MakeButton(strTestButton3, 2, lineTest);
			uiTestButton4 = MakeButton(strTestButton4, 3, lineTest);
			*/
			#endregion

			#region DefineAddonUI
			//line13
			uiUndress.button.onClick.AddListener(OnUndressClick);
//			uiUndressHalf.button.onClick.AddListener(OnUndressHalfClick);
			uiUndressStop.button.onClick.AddListener(OnUndressStopClick);
			uiReverse.button.onClick.AddListener(OnReverseClick);
			uiUndressAndReverse.button.onClick.AddListener(OnUndressAndReverseClick);
			uiUndressRecover.button.onClick.AddListener(OnUndressRecoverClick);
			uiUndressRemove.button.onClick.AddListener(OnUndressRemoveClick);
			/* for next release
			uiTakeControlOfExpression.button.onClick.AddListener(OnTakeControlOfExpressionClick);
			uiStopControlOfExpression.button.onClick.AddListener(OnStopControlOfExpressionClick);
			
			uiTestButton1.button.onClick.AddListener(OnTestButton1Click);				
			uiTestButton2.button.onClick.AddListener(OnTestButton2Click);
			uiTestButton3.button.onClick.AddListener(OnTestButton3Click);
			uiTestButton4.button.onClick.AddListener(OnTestButton4Click);
			*/
			#endregion			
		}
		
		#region Define UI Function Addon
		
		public void OnExpandAddon1ValueOnly(){OnExpandCommonValueOnly("Addon1");}
		public void OnCollapseAddon1ValueOnly(){OnCollapseCommonValueOnly("Addon1");}
		
		public void OnExpandCommonValueOnly(string type){
			if(type == "Addon1"){
				expandAddon1 = true;
			}
		}
		
		public void OnCollapseCommonValueOnly(string type){
			if(type == "Addon1"){
				expandAddon1 = false;
			}
		}
		
		public void OnExpandAddon1(){OnExpandCommon("Addon1");}
		public void OnCollapseAddon1(){OnCollapseCommon("Addon1");}

		public void OnExpandCommon(string type){
			if(type == "Addon1"){
				expandAddon1 = true;
			}
			worldUi.RemoveMenuBody();
			worldUi.MakeMenuBody();
		}
		
		public void OnCollapseCommon(string type){
			if(type == "Addon1"){
				expandAddon1 = false;
			}
			worldUi.RemoveMenuBody();
			worldUi.MakeMenuBody();
		}
		
		public void OnUndressClick(){
			addonClothSim.RecoverClothesState();
			addonClothSim.BackupClothesState();
			addonClothSim.Undress("Undress");
		}

		/*
		public void OnUndressHalfClick(){
			addonClothSim.RecoverClothesState();
			addonClothSim.BackupClothesState();
			addonClothSim.Undress("UndressHalf");			
		}
		*/
		
		public void OnReverseClick(){
			addonClothSim.RecoverClothesState();
			addonClothSim.BackupClothesState();
			addonClothSim.Undress("Reverse");
		}
		
		public void OnUndressAndReverseClick(){
			addonClothSim.RecoverClothesState();
			addonClothSim.BackupClothesState();
			addonClothSim.Undress("UndressAndReverse");
		}
		
		public void OnUndressStopClick(){
			addonClothSim.UndressStop();
		}

		public void OnUndressRecoverClick(){
			addonClothSim.RemoveResetClothes();
			addonClothSim.RecoverClothesState();
			addonClothSim.ResetClothesState();
		}

		public void OnUndressRemoveClick(){
			addonClothSim.RecoverClothesState();
			addonClothSim.BackupClothesState();
			addonClothSim.RemoveClothes();
		}

		/*
		public void OnTakeControlOfExpressionClick(){
			addonTakeControl.TakeControlOfExpression();
//			addonTakeControl.TakeControlOfExpression();
		}

		public void OnStopControlOfExpressionClick(){
			addonTakeControl.ReturnControlOfExpression();
		}
		*/

		/*
		public void OnTestButton1Click(){
		}

		public void OnTestButton2Click(){
		}
		
		public void OnTestButton3Click(){
		}
		
		public void OnTestButton4Click(){
		}
		*/
		#endregion

		#region Define Alias
		public UIDynamicButton MakeButton(string name, int x, int y, float width = 0f, float height = 0f){
			return worldUi.MakeButtonForAddon(name, x, y, width, height);
		}

		public UIDynamicSlider MakeSlider(string name, int x, int y, float min, float max, float current){
			return worldUi.MakeSlider(name, x, y, min, max, current);
		}
		#endregion
	}
}